/***********************************************************
 * darken.c
 * written by Steve Sprang
 * Copyright  1997
 *
 * Aurora v0.2A
 *
 * A simple filter to darken an image.
 * Will go away when I add brightness/contrast controls...
 **********************************************************/
 
#include "filter.h"

char name[] = "Darken";

void aurora_name(char * &string)
{
	string = name;
}

bool aurora_filter(BBitmap *input, BView *painter)
{
	if(input->ColorSpace() != B_RGB_32_BIT) {
		return false;
	}
	else {
		BRect		bounds = input->Bounds();
		
		uchar 		*srcbits = (uchar *) input->Bits();
		long		xmod = input->BytesPerRow();
		int			x,y, width, height;
		
		width = bounds.Width();
		height = bounds.Height();
		
		for(y = 0; y <= height; y++) {
			for(x = 0; x <= width; x++) {
				// red, green, blue
				srcbits[x*4 + 2] = max(0, (int) srcbits[x*4 + 2] - 5);
				srcbits[x*4 + 1] = max(0, (int) srcbits[x*4 + 1] - 5);
				srcbits[x*4] = max(0, (int) srcbits[x*4] - 5);
			}
			srcbits += xmod;
		}
	}
	return true;
}