/***********************************************************
 * diffuse.c
 * written by Steve Sprang
 * Copyright  1997
 *
 * Aurora v0.2A
 *
 * Simple diffusion filter...
 **********************************************************/

#include "filter.h"

char name[] = "Diffuse";

void aurora_name(char * &string)
{
	string = name;
}

bool aurora_filter(BBitmap *input, BView *painter)
{
	if(input->ColorSpace() != B_RGB_32_BIT) {
		return false;
	}
	else {
		BRect		bounds = input->Bounds();
		BBitmap		*temp = new BBitmap(bounds, B_RGB_32_BIT, true);
		BView		*vw = new BView(bounds, "", B_FOLLOW_NONE, B_WILL_DRAW);
		
		temp->AddChild(vw);
		temp->Lock();
		vw->DrawBitmap(input);
		vw->Sync();
		temp->Unlock();
		
		uchar 		*srcbits = (uchar *) input->Bits();
		uchar 		*destbits = (uchar *) temp->Bits();
		long		xmod = input->BytesPerRow();
		int			x,y, width, height, diffuse;
		
		width = bounds.Width();
		height = bounds.Height();
		
		for(y = 0; y <= height; y++) {
			for(x = 0; x <= width; x++) {
				diffuse = (x + (3 - (rand() % 7))) * 4;
				
				if( diffuse < 0) {
					diffuse = 0;
				}
				else if(diffuse > width * 4) {
					diffuse = width * 4;
				}
				
				// red, green, blue
				srcbits[x*4 + 2] = destbits[diffuse + 2];
				srcbits[x*4 + 1] = destbits[diffuse + 1];
				srcbits[x*4] = destbits[diffuse];
			}
			srcbits += xmod;
			destbits += xmod;
		}
		delete temp;
	}
	return true;
}